#!/usr/bin/env python
# -*- coding: utf-8 -*-
import json
from kafka import KafkaProducer
from kafka import KafkaConsumer
from gm_rpcd.all import bind
import traceback
from django.conf import settings
from follow.views.auto_follow import auto_follow_user
from click.views.auto_click import auto_click_user
from comment.views.auto_comment import auto_comment_user
import datetime
import time
import logging


def kafka_consum(topic_name=None):
    try:
        topic_name = settings.KAFKA_TOPIC_NAME if not topic_name else topic_name
        consumser_obj = KafkaConsumer(topic_name, bootstrap_servers=[settings.KAFKA_BROKER_LIST])
        logging.info("get consumser_obj:%s" % consumser_obj)
        while True:
            msg_dict = consumser_obj.poll(timeout_ms=100)
            for msg_key in msg_dict:
                consume_msg = msg_dict[msg_key]
                for msg in consume_msg:
                    card_info = json.loads(msg.value)
                    logging.info("get card_info:%s" % card_info)
                    # 代表当天数据
                    current_push_time = card_info['current_push_time']
                    create_time = card_info['create_time']
                    action_type = card_info['action_type']
                    nowtime = datetime.datetime.now()
                    # nowtime = now.strftime('%Y-%m-%d %H:%M:%S')
                    push_time_date = datetime.datetime.strptime(current_push_time, '%Y-%m-%d %H:%M:%S')

                    logging.info("get push_time_date:%s" % push_time_date)
                    logging.info("get push_time_date:%s" % type(push_time_date))

                    logging.info("get nowtime:%s" % nowtime)
                    logging.info("get nowtime:%s" % type(nowtime))

                    if push_time_date <= nowtime:  # push_time已经到时间了 需要去下发
                        logging.info("get push_time_date:%s" % push_time_date)
                        # 判断如果当前的push_time 和当前的创建时间一样  需要给push_time下发真的push时间
                        if current_push_time == create_time:
                            auto_follow_user(card_info)
                            auto_comment_user(card_info)
                            auto_click_user(card_info)

                        else:
                            # current_push_time = card_info['current_push_time']
                            # current_time = datetime.datetime.strptime(current_push_time, '%Y-%m-%d %H:%M:%S')
                            # now = datetime.datetime.now()
                            # 需要判断是否真的已经下发完了 如果是时间过了但是没有下发直接下发了
                            # 当前已下发完 需要判断最新一次的下发时间是否是今天 是的话直接跳过
                            if card_info['have_pust_num'] == card_info['need_pust_num']:
                                if nowtime.day - push_time_date.day == 0:  # 是今天的话直接跳过
                                    pass
                                else:
                                    # 再存储起来？
                                    pass
                            # 还有一种是下发时间还没有到 之前没有轮询到
                            else:
                                if card_info['have_pust_num'] <= card_info['need_pust_num'] and \
                                        push_time_date < nowtime:
                                    if action_type == "comment":  # 在这里去调评论的接口
                                        logging.info("get------------------comment-----------------")
                                        # 调完接口后需要再次去拿新的push_time的时间
                                        auto_comment_user(card_info)

                                    elif action_type == "click":  # 在这里去调点赞的接口
                                        logging.info("get--------------click---------------------")

                                        auto_click_user(card_info)

                                    elif action_type == "follow":  # 在这里去调关注的接口
                                        logging.info("get----------follow-------------------------")

                                        auto_follow_user(card_info)

                else:  # push_time时间未到 需要等待
                    logging.info("push_time时间未到========================需要等待")
                    pass

    except:
        logging.error("catch exception,err_msg:%s" % traceback.format_exc())
