# -*- coding: UTF-8 -*-
import datetime
import time
import logging
from libs.error import logging_exception
import traceback
import random
from kafka import KafkaProducer
import random
from django.conf import settings
import json
from libs.cache import redis_client
from moment.views.get_keyword import GetContentKeyWords
import pymysql

logger = logging.getLogger(__name__)


def strTimeProp(start, end, prop, frmt):
    stime = time.mktime(time.strptime(start, frmt))
    etime = time.mktime(time.strptime(end, frmt))
    ptime = stime + prop * (etime - stime)
    return int(ptime)


def randomDate(create_time, frmt='%Y-%m-%d %H:%M:%S', action_type=None):
    if action_type in ("follow", "click"):
        action_num = random.randint(1, 3)

    if action_type == "comment":
        action_num = random.randint(0, 1)

    start = str(create_time + datetime.timedelta(hours=2))
    end = str(create_time + datetime.timedelta(hours=4))

    random_times = [randomDate_six_one(start, end, frmt) for _ in range(action_num)]
    have_sort_times = sorted(random_times, key=lambda date: get_list(date))

    return have_sort_times


def randomDate_six_one(start, end, frmt='%Y-%m-%d %H:%M:%S'):
    return time.strftime(frmt, time.localtime(strTimeProp(start, end, random.random(), frmt)))


def get_list(date):
    return datetime.datetime.strptime(date, "%Y-%m-%d %H:%M:%S").timestamp()


def get_one_six_days_random_time(frmt='%Y-%m-%d %H:%M:%S', num_days=0, action_type=None, content_level=0):
    try:
        if num_days == 1 and action_type in ("follow", "click") and content_level < 3:
            action_num = random.randint(1, 3)

        if num_days == 1 and action_type in ("follow") and content_level >= 3:
            action_num = random.randint(5, 10)

        if num_days <= 15 and num_days > 1 and action_type in ("follow", "click") and content_level < 3:
            action_num = random.randint(0, 1)

        if num_days <= 15 and num_days > 1 and action_type in ("follow") and content_level >= 3:
            action_num = random.randint(0, 5)

        if num_days == 1 and action_type in ("click") and content_level >= 3:
            action_num = random.randint(6, 12)

        if num_days <= 15 and num_days > 1 and action_type in ("click") and content_level >= 3:
            action_num = random.randint(0, 6)

        if num_days >= 1 and num_days <= 6 and action_type in ("comment"):
            if content_level <= 3:
                action_num = random.randint(0, 1)
            else:
                action_num = random.randint(2, 4)

        now = datetime.datetime.now()
        zeroday = str(datetime.datetime(now.year, now.month, now.day, 0, 0, 0))
        lastday = str(datetime.datetime(now.year, now.month, now.day + 1, 0, 0, 0))
        random_times = [randomDate_six_one(zeroday, lastday, frmt) for _ in range(action_num)]
        have_sort_times = sorted(random_times, key=lambda date: get_list(date))
        return have_sort_times
    except:
        logger.error("catch exception,err_log:%s" % traceback.format_exc())
        return False


def get_ten_last_days_random_time(num_days=None, frmt='%Y-%m-%d %H:%M:%S', action_type=None, content_level=0):
    try:
        ##比较当前时间和最后一次创建时间的差
        now = datetime.datetime.now()
        if num_days > 15 and action_type in ("follow"):
            action_num = random.randint(0, 2)
            add_number = 10

        if num_days > 15 and action_type in ("click"):
            if content_level < 3:
                action_num = random.randint(0, 1)
                add_number = 6

            else:
                action_num = random.randint(0, 2)
                add_number = 5

        if num_days > 6 and action_type in ("comment"):
            if content_level <= 3:
                action_num = random.randint(0, 1)
                add_number = 10
            else:
                action_num = random.randint(0, 2)
                add_number = 10

        zeroday = str(datetime.datetime(now.year, now.month, now.day + add_number, 0, 0, 0))
        lastday = str(datetime.datetime(now.year, now.month, now.day + add_number + 1, 0, 0, 0))
        random_times = [randomDate_six_one(zeroday, lastday, frmt) for _ in range(action_num)]
        have_sort_times = sorted(random_times, key=lambda date: get_list(date))
        return have_sort_times
    except:
        logger.error("catch exception,err_log:%s" % traceback.format_exc())
        return False


def get_content_time_by_create_time(create_time="", content_level=0, action_type=None, is_today=False):
    try:
        min = 60
        now = datetime.datetime.now()
        createt = datetime.datetime.strptime(create_time, '%Y-%m-%d %H:%M:%S')
        nowt = now.strftime('%Y-%m-%d %H:%M:%S')
        ##获取创建时间和当前时间的相差秒数
        num = (now - createt).total_seconds()
        num_days = now.day - createt.day
        # 创建时间切换成分钟数便于比较
        mins = divmod(num, min)[0]
        ##根据转换后的分钟数进行比较
        ##转化成分数后进行一层一层的比较
        if is_today == True:
            if mins < 120 and num_days == 0:
                print("时候未到")
                return []

            ##进入当天的下发时间
            elif mins >= 120 and num_days == 0:
                print("当天")
                get_time = randomDate(create_time=createt, action_type=action_type)
                return get_time

        else:
            if mins < 120 and num_days == 0:
                print("时候未到")
                return []

            ##进入当天的下发时间
            elif mins >= 120 and mins <= 4 * 60 and num_days == 0:
                print("当天")
                get_time = randomDate(create_time=createt, action_type=action_type)
                print(get_time)
                return get_time

            elif num_days >= 1 and num_days <= 6:
                print("1-6天的")
                get_time = get_one_six_days_random_time(content_level=content_level, num_days=num_days,
                                                        action_type=action_type)
                print(get_time)
                return get_time

            elif num_days > 6 and num_days <= 365:
                print("6天后的")
                push_time = '2019-12-16 16:23:20'
                get_time = get_ten_last_days_random_time(num_days=num_days, content_level=content_level)
                print(get_time)
                return get_time

            else:
                ##需要删掉kafka的数据不再进行下发
                print("所有下发结束")
                return []

    except:
        logger.error("catch exception,err_log:%s" % traceback.format_exc())


def get_click_follow_time_by_create_time(create_time="", content_level=0, action_type=None):
    try:
        min = 60
        now = datetime.datetime.now()
        createt = datetime.datetime.strptime(create_time, '%Y-%m-%d %H:%M:%S')
        nowt = now.strftime('%Y-%m-%d %H:%M:%S')
        ##获取创建时间和当前时间的相差秒数
        num = (now - createt).total_seconds()
        num_days = now.day - createt.day
        # 创建时间切换成分钟数便于比较
        mins = divmod(num, min)[0]
        ##根据转换后的分钟数进行比较
        ##转化成分数后进行一层一层的比较

        if mins < 120 and num_days == 0:
            print("时候未到")
            return []

            ##进入当天的下发时间
        elif mins >= 120 and num_days == 0:
            print("当天")
            get_time = randomDate(create_time=createt, action_type=action_type)
            logging.info("拿到当天的时间 get  get_time:%s" % get_time)
            return get_time

        elif num_days == 1:
            print("1天的")

            get_time = get_one_six_days_random_time(num_days=num_days, action_type=action_type,
                                                    content_level=content_level)

            logging.info("1天的 get  get_time:%s" % get_time)

            print(get_time)
            return get_time

        elif num_days > 1 and num_days <= 15:
            print("2-15天后的")
            get_time = get_one_six_days_random_time(num_days=num_days, action_type=action_type,
                                                    content_level=content_level)
            logging.info("2-15天后的的时间 get  get_time:%s" % get_time)

            print(get_time)
            return get_time

        elif num_days > 15 and num_days <= 365:
            ##需要删掉kafka的数据不再进行下发
            print("15天后的")

            get_time = get_ten_last_days_random_time(num_days=num_days, action_type=action_type,
                                                     content_level=content_level)
            logging.info("拿到当天的时间 get  get_time:%s" % get_time)

            return get_time

        else:
            print("所有下发结束")
            return []

    except:
        logger.error("catch exception,err_log:%s" % traceback.format_exc())


def save_data_to_kafka(card_info):
    try:
        producer = KafkaProducer(bootstrap_servers=settings.KAFKA_BROKER_LIST)
        topic = settings.KAFKA_TOPIC_NAME
        producer.send(topic, json.dumps(card_info).encode())
        producer.close()

    except:
        logging.error("catch exception,err_msg:%s" % traceback.format_exc())


def get_vest_userid(need_comment_num=0):
    user_list = []
    if need_comment_num:
        for i in range(0, need_comment_num):
            user_data = open("moment/views/vest_ids.txt", "r")
            for i in user_data.readlines():
                user_list.append(int(i.strip()))
        user_ids = random.sample(user_list, need_comment_num)
        return user_ids
    else:
        return 12345


def get_vest_userid_and_comment(need_comment_num=0, tag_names=[], card_id=0):
    try:
        ##先根据card_id回去内容提取关键字
        db_zhengxing_eagle = pymysql.connect(host=settings.DATABASES.HOST, port=3306, user=settings.DATABASES.USER,
                                             password=settings.DATABASES.PASSWORD,
                                             db=settings.DATABASES.NAME,
                                             cursorclass=pymysql.cursors.DictCursor)
        zhengxing_cursor = db_zhengxing_eagle.cursor()
        sql = 'select name from api_tag where id = %s ' % (card_id)
        zhengxing_cursor.execute(sql)
        data = zhengxing_cursor.fetchall()
        logging.info("get data:%s" % data)
        zhengxing_cursor.close()

        ck = GetContentKeyWords()
        keywords = ck.get_keywords(data, len(ck.tag_list))
        tag_names.append(keywords)

        if need_comment_num:
            all_comment_list = []
            redis_key = "vest_kyc_tag_content_data"
            all_keys = redis_client.hkeys(redis_key)
            all_keys_name = []
            for item in all_keys:
                all_keys_name.append(str(item, encoding="utf-8"))
            for item in tag_names:
                if item in all_keys_name:
                    service_closure_tags = redis_client.hget(redis_key, item)
                    closure_tags = json.loads(service_closure_tags)
                    all_comment_list.extend(closure_tags)
            if all_comment_list:
                content = random.sample(all_comment_list, need_comment_num)
            else:
                content = None

        else:
            content = None

        logging.info("get content:%s" % content)
        return content

    except:
        logging.error("catch exception,err_msg:%s" % traceback.format_exc())
